routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\BukuTamuController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\FasilitasController;
use App\Http\Controllers\FasilitasKamarController;
use App\Http\Controllers\KamarController;
use App\Http\Controllers\PendapatanController;
use App\Http\Controllers\TipeKamarController;
use App\Http\Controllers\TransaksiController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [DashboardController::class, 'home'])->name('landing');
Route::get('kamar-hotel', [DashboardController::class, 'kamar'])->name('kamar.hotel');
Route::get('kamar-hotel-show/{id}', [DashboardController::class, 'showKamar'])->name('kamar.hotel.show');
Route::get('fasilias-hotel', [DashboardController::class, 'fasilitas'])->name('fasilitas.hotel');

Route::group(['middleware' => 'guest'], function(){
    Route::get('login', [AuthController::class, 'login'])->name('login');
    
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
    
    Route::post('signup', [AuthController::class, 'signup'])->name('signup');
    
    Route::get('register', [AuthController::class, 'register'])->name('register');
});

Route::group(['middleware' => 'auth'], function(){
    Route::post('logout', [AuthController::class, 'logout'])->name('logout');
    Route::resource('cart', CartController::class);
    Route::post('cart-destroy-all', [CartController::class, 'destroyAll'])->name('cart.destroy.all');
    Route::get('transaksi', [TransaksiController::class, 'index'])->name('transaksi.index');
    Route::post('transaksi-store', [TransaksiController::class, 'store'])->name('transaksi.store');
    Route::get('invoice/{id?}', [TransaksiController::class, 'invoice'])->name('transaksi.invoice');
    Route::get('invoice-show/{id?}', [TransaksiController::class, 'show'])->name('transaksi.invoice.show');
    Route::group(['middleware' => ['hasrole:admin']], function(){
        Route::resource('kamar', KamarController::class);
        Route::resource('fasilitas', FasilitasController::class);
        Route::resource('fasilitas-kamar', FasilitasKamarController::class);
        Route::resource('tipe-kamar', TipeKamarController::class);
    });
    Route::group(['middleware' => ['hasrole:guider']], function(){
        Route::get('buku-tamu', [BukuTamuController::class, 'index'])->name('buku.tamu.index');
        Route::get('buku-tamu/{id?}/show', [BukuTamuController::class, 'show'])->name('buku.tamu.show');
        Route::put('buku-tamu/{id?}/update', [BukuTamuController::class, 'update'])->name('buku.tamu.update');
        Route::get('pendapatan', [PendapatanController::class, 'index'])->name('pendapatan.index');
        Route::post('pendapatan/total', [PendapatanController::class, 'getTotalPendapatan'])->name('pendapatan.total');
    });
});

app/Models/FasilitasKamar.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class FasilitasKamar extends Model
{
    use HasFactory;
    protected $guarded = [];

    public function kamar(){
        return $this->belongsTo(kamar::class);
    }

    public function fasilitas(){
        return $this->belongsTo(Fasilitas::class);
    }
}

app/Http/Controllers/FasilitasKamarController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\FasilitasKamarRequest;
use App\Models\FasilitasKamar;
use Yajra\DataTables\Facades\DataTables;

class FasilitasKamarController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if(request()->ajax()){
            $model = FasilitasKamar::with('kamar', 'fasilitas')->get();
            return DataTables::of($model)
                ->addColumn('_', function($row){
                    return '<button type="button" class="btn btn-info btn-sm" onclick="view('.$row->id.')">Lihat</button>
                        <button type="button" class="btn btn-warning text-light btn-sm" onclick="edit('.$row->id.')">Edit</button>
                        <button type="button" class="btn btn-danger btn-sm" onclick="destroy('.$row->id.')">Hapus</button>';
                })
                ->rawColumns(['_'])
                ->make(true);
        }

        return view('pages.fasilitas_kamar.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.fasilitas_kamar.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(FasilitasKamarRequest $request)
    {
        if(FasilitasKamar::create([
            'kamar_id' => request('kamar_id'),
            'fasilitas_id' => request('fasilitas_id'),
        ])){
            return response()->json([
                'status' => true,
                'message' => 'Fasilitas Kamar berhasil ditambahkan'
            ]);
        }
        return response()->json([
            'status' => false,
            'message' => 'Fasilitas Kamar gagal ditambahkan'
        ]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $model = FasilitasKamar::find($id);
        return view('pages.fasilitas_kamar.show', compact('model'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $model = FasilitasKamar::find($id);
        return view('pages.fasilitas_kamar.edit', compact('model'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(FasilitasKamar $request, $id)
    {
        $model  = FasilitasKamar::find($id);
        if($model->update([
            'kamar_id' => request('kamar_id'),
            'fasilitas_id' => request('fasilitas_id'),
        ])){
            return response()->json([
                'status' => true,
                'message' => 'Fasilitas Kamar berhasil diubah'
            ]);
        }
        return response()->json([
            'status' => false,
            'message' => 'Fasilitas Kamar gagal diubah'
        ]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $model = FasilitasKamar::find($id);
        if($model->delete()){
            return response()->json([
                'status' => true,
                'message' => 'Fasilitas Kamar berhasil dihapus'
            ]);
        }
        return response()->json([
            'status' => false,
            'message' => 'Fasilitas Kamar gagal dihapus'
        ]);
    }
}

resources/views/pages/fasilitas_kamar/create.blade.php
{!! Form::open(['id' => 'formCreate']) !!}
    @include('pages.fasilitas_kamar.form')
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
        <button type="button" class="btn btn-primary btn-sm" onclick="store()">Tambah</button>
    </div>
{!! Form::close() !!}

resources/views/pages/fasilitas_kamar/edit.blade.php
{!! Form::model($model, ['id' => 'formEdit']) !!}
    @include('pages.fasilitas_kamar.form')
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
        <button type="button" class="btn btn-primary btn-sm" onclick="update({{ $model->id }})">Ubah</button>
    </div>
{!! Form::close() !!}

resources/views/pages/fasilitas_kamar/form.blade.php
<div class="form-group">
    <label for="kamar_id">Tipe Kamar</label>
    @if(isset($model))
        {!! Form::hidden('_method', 'PUT') !!}
    @endif
    {!! Form::select('kamar_id', ['' => 'Pilih']+App\Models\Kamar::pluck('name', 'id')->toArray(), null, ['class' => 'form-control', 'id' => 'kamar_id']) !!}
</div>
<div class="form-group">
    <label for="tipe">Fasilitas</label>
    {!! Form::select('fasilitas_id', ['' => 'Pilih']+App\Models\Fasilitas::pluck('name', 'id')->toArray(), null, ['class' => 'form-control', 'id' => 'fasilitas_id']) !!}
</div>

resources/views/pages/fasilitas_kamar/form_script.blade.php
<script>
    var table;
    $(() => {
        table = $('#table').DataTable({
            searching: false,
            lengthChange: false,
            info: false,
            paging: false,
            processing: true,
            serverSide: true,
            responsive: true,
            ajax: '',
            columns: [
                {data: 'kamar.name', name:'fasilitas_kamars.kamar.name'},
                {data: 'fasilitas.name', name:'fasilitas_kamars.fasilitas.name'},
                {data: '_', searchable: false}
            ]
        });
    });

    function create(){
        $.ajax({
            url: '{{ route('fasilitas-kamar.create') }}',
            success: (response) => {
                bootbox.dialog({
                    title: 'Tambah Fasilitas Kamar',
                    message: response,
                    closeButton: true
                });
            }
        });
    }

    function store(){
        $('#formCreate .alert').remove();
        $.ajax({
            url: '{{ route('fasilitas-kamar.store') }}',
            type: 'post',
            dataType:'json',
            data: $('#formCreate').serialize(),
            success: (response) => {
                if(response.status){
                    Swal.fire({
                        title: 'success',
                        text: response.message,
                        icon: 'success'
                    });
                    table.ajax.reload();
                }else {
                    Swal.fire({
                        title: 'gagal',
                        text: response.message,
                        icon: 'error'
                    });
                }
                bootbox.hideAll();
            },
            error: (err) => {
                var response = JSON.parse(err.responseText);
                $('#formCreate').prepend(validation(response));
            }
        });
    }

    function edit(id){
        let url = "{{ route('fasilitas-kamar.edit', ":id") }}"
        url = url.replace(':id', id);
        $.ajax({
            url,
            success: (response) => {
                bootbox.dialog({
                    title: 'Ubah Fasilitas Kamar',
                    message: response,
                    closeButton: true
                });
            }
        });
    }

    function update(id){
        $('#formEdit .alert').remove();

        let url = "{{ route('fasilitas-kamar.update', ":id") }}";
        url = url.replace(':id', id);
        $.ajax({
            url,
            type: 'post',
            dataType: 'json',
            data: $('#formEdit').serialize(),
            success: (response) => {
                if(response.status){
                    Swal.fire({
                        title: 'success',
                        text: response.message,
                        icon: 'success'
                    });
                    table.ajax.reload();
                }else {
                    Swal.fire({
                        title: 'gagal',
                        text: response.message,
                        icon: 'error'
                    });
                }
                bootbox.hideAll();
            },
            error: (err) => {
                let response = JSON.parse(err.responseText);
                $('#formEdit').prepend(validation(response));
            }
        });
    }

    function view(id){
        let url = "{{ route('fasilitas-kamar.show', ":id") }}";
        url = url.replace(":id", id);

        $.ajax({
            url,
            success: (response) => {
                bootbox.dialog({
                    title: 'Detail Fasilitas Kamar',
                    message: response,
                    closeButton: true
                });
            }
        });
    }

    function destroy(id){
        let data = {'_token': "{{ csrf_token() }}", '_method': 'DELETE'};
        
        let url  = "{{ route('fasilitas-kamar.destroy', ":id") }}";
        url = url.replace(':id', id);

        Swal.fire({
            title: 'Yakin hapus data?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Hapus',
        }).then((result) => {
            if(result.isConfirmed){
                $.ajax({
                    url,
                    method: 'post',
                    data,
                    success: (response) => {
                        if(response.status){
                            Swal.fire({
                                title: 'success',
                                text: response.message,
                                icon: 'success'
                            });
                            table.ajax.reload();
                        }else {
                            Swal.fire({
                                title: 'gagal',
                                text: response.message,
                                icon: 'error'
                            });
                        }
                    }
                });
            }
        });
    }

    function validation(errors){
        var validations = '<div class="alert alert-danger">';
        $.each(errors.errors, function(i, error){
            validations += error[0]+'<br>';
        });
        validations += '</div>';
        return validations;
    }
</script>

resources/views/pages/fasilitas_kamar/index.blade.php
<x-adminLayout pageName="Fasilitas Kamar">
    <div class="d-flex justify-content-end mb-3">
        <button class="btn btn-success btn-sm text-end" onclick="create()">Tambah</button>
    </div>
    <table class="table table-bordered table-condensed" id="table">
        <thead>
            <tr>
                <th>Tipe Kamar</th>
                <th>Fasilitas</th>
                <th>Aksi</th>
            </tr>
        </thead>
        <tbody></tbody>
    </table>
    @slot('script')
        @include('pages.fasilitas_kamar.form_script')
    @endslot
</x-adminLayout>

resources/views/pages/fasilitas_kamar/show.blade.php
{!! Form::model($model, ['id' => 'formShow']) !!}
    <hr>
        <h5 class="mb-3">Kamar</h5>
    <hr>
    <div class="mb-3 text-center">
        <img id="image-kamar" src="{{ asset('storage/'.$model->kamar->banner) }}" class="w-75 rounded" alt="">
    </div>
    <div class="row">
        <div class="col-md-3">
            <h6>Tipe Kamar :</h6>
        </div>
        <div class="col-md-9">
            <p>{{ $model->kamar->tipe }}</p>
        </div>
    </div>
    <div class="row">
        <div class="col-md-3">
            <h6>Jumlah :</h6>
        </div>
        <div class="col-md-9">
            <p>{{ $model->kamar->jumlah }}</p>
        </div>
    </div>
    <hr>
        <h5 class="mb-3">Fasilitas</h5>
    <hr>
    <div class="row">
        <div class="col-md-4">
            <h6>Nama Fasilitas :</h6>
        </div>
        <div class="col-md-8">
            <p>{{ $model->fasilitas->name }}</p>
        </div>
    </div>
    <div class="row">
        <div class="col-md-4">
            <h6>Deskripsi :</h6>
        </div>
        <div class="col-md-8">
            <p>{{ $model->fasilitas->desc }}</p>
        </div>
    </div>
    <div class="mb-3 text-center">
        <img id="image-fasilitas" src="{{ asset('storage/'.$model->fasilitas->picture) }}" class="w-75 rounded" alt="">
    </div>
    <div class="text-right">
        <button type="button" class="btn btn-secondary btn-sm" onclick="bootbox.hideAll()">Batal</button>
    </div>
{!! Form::close() !!}